(function() {
  var testConnectivity, toggleEwsServerUrlVisibility, validateLicenseKey;
  validateLicenseKey = function(element) {
    return $.getJSON('/admin/validatelicensekey', {
      licenseKey: $(this).val()
    }, function(data, textStatus) {
      if (data.LicenseKeyValidity === 'Valid') {
        return $("#license_validation").addClass("valid").removeClass("invalid").text(data.LicenseKeyValidity);
      } else if (data.LicenseKeyValidity === 'Not Valid') {
        return $("#license_validation").removeClass("valid").addClass("invalid").text(data.LicenseKeyValidity);
      }
    });
  };
  toggleEwsServerUrlVisibility = function(element) {
    if ($("#enable_autodiscovery").attr("checked") === "checked") {
      return $(".field.ews_url").hide();
    } else {
      return $(".field.ews_url").show();
    }
  };
  testConnectivity = function(element) {
    $("#connectivity_test_result").html("<div class='loading'>Testing connection to Exchange server...</div>");
    $.ajax({
      url: '/admin/testconnection',
      dataType: 'json',
      data: {
        Username: $("#Username").val(),
        Password: $("#Password").val(),
        EnableAutodiscovery: $("#enable_autodiscovery").attr("checked") === "checked",
        EwsServerUrl: $("#EwsServerUrl").val()
      },
      success: function(data, textStatus) {
        if (data && data.TestSucceeded) {
          return $("#connectivity_test_result").html("<div class='success'>Connection succeeded</div>");
        } else {
          return $("#connectivity_test_result").html("<div class='failure'>Connection failed. " + data.Message + "</div>");
        }
      },
      error: function() {
        return $("#connectivity_test_result").html("<div class='failure'>Internal error - we couldn't check the connection.</div>");
      }
    });
    return false;
  };
  $(function() {
    $.ajaxSetup({
      cache: false
    });
    $("#LicenseKey").bindWithDelay("keyup", validateLicenseKey, 500);
    $("#enable_autodiscovery").click(toggleEwsServerUrlVisibility);
    toggleEwsServerUrlVisibility();
    return $(".actions a").click(testConnectivity);
  });
}).call(this);
